<div><link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/uikit/2.24.2/css/uikit.almost-flat.min.css"/><section><h1>Badge</h1><p class="uk-article-lead">Easlily create nicely looking badges to label and highlight your content.</p></section><section><h2>Usage</h2><p><code>npm install react-uikit-badge --save;</code></p><p>ES6 <br/><code>import Badge from &#x27;react-uikit-badge&#x27;;</code><br/></p><p>ES5 <br/><code>var Badge = require(&#x27;react-uikit-badge&#x27;);</code></p><p><span class="uk-badge  uk-badge-danger">Note</span>  UIkit css is not included. You can get it from <a href="http://getuikit.com/">getuikit.com</a>. This has been tested with UIKit version 2.24.2.</p><hr class="uk-article-divider"/><p>Badges can be either <code>&lt;span&gt;</code> or <code>&lt;div&gt;</code>. They are inline <code>&lt;span&gt;</code> by default.</p><p>Add the <code>block</code> prop to create a <code>&lt;div&gt;</code>instead of a <code>&lt;span&gt;</code>.</p><p>Text can be added either as children, <code>&lt;Badge&gt;Awesome&lt;/Badge&gt;</code> or by setting the <code>body</code> prop, <code>&lt;Badge body=&#x27;Awesome&#x27;/&gt;</code>.</p><h3 class="example">Example</h3><span class="uk-badge">Info</span> <span class="uk-badge">New</span> <span class="uk-badge">Free</span><h4 class="code">Code</h4><pre class="xml"><code class="xml">&lt;Badge&gt;Info&lt;/Badge&gt; &lt;Badge&gt;New&lt;/Badge&gt; &lt;Badge&gt;Free&lt;/Badge&gt;</code></pre></section><section><h2>Badge notifications</h2><p>Add the <code>notification</code> prop to indicate a notification. Typically it is used with numbers.</p><h3 class="example">Example</h3><span class="uk-badge  uk-badge-notification">3</span> <span class="uk-badge  uk-badge-notification">20</span> <span class="uk-badge  uk-badge-notification">100</span><h4 class="code">Code</h4><pre class="xml"><code class="xml">&lt;Badge notification&gt;3&lt;/Badge&gt; &lt;Badge notification&gt;20&lt;/Badge&gt; &lt;Badge notification&gt;100&lt;/Badge&gt;</code></pre></section><section><h2>Badge contexts</h2><p>Add the <code>context=&#x27;success&#x27;</code> or <code>context=&#x27;warning&#x27;</code> or<code>context=&#x27;danger&#x27;</code> prop for additional contexts.</p><h3 class="example">Example</h3><span class="uk-badge  uk-badge-success">success</span> <span class="uk-badge  uk-badge-warning">warning</span> <span class="uk-badge  uk-badge-danger">danger</span><br/><span class="uk-badge  uk-badge-success uk-badge-notification">1</span> <span class="uk-badge  uk-badge-warning uk-badge-notification">10</span> <span class="uk-badge  uk-badge-danger uk-badge-notification">99+</span><h4 class="code">Code</h4><pre class="xml"><code class="xml">&lt;Badge context=&#x27;success&#x27;&gt;success&lt;/Badge&gt; &lt;Badge context=&#x27;warning&#x27;&gt;warning&lt;/Badge&gt; &lt;Badge context=&#x27;danger&#x27;&gt;danger&lt;/Badge&gt;&lt;br /&gt;
&lt;Badge notification context=&#x27;success&#x27;&gt;1&lt;/Badge&gt; &lt;Badge notification context=&#x27;warning&#x27;&gt;10&lt;/Badge&gt; &lt;Badge notification context=&#x27;danger&#x27;&gt;99+&lt;/Badge&gt;</code></pre></section><section><h2>Badge Props</h2><p><code>&lt;Badge&gt;</code> props and their types.</p><p>See <a href="https://github.com/otissv/react-uikit-base">base</a> for additional props.</p><table class="uk-table"><thead><tr><th class="uk-text-left">Prop</th><th class="uk-text-left">Type</th></tr></thead><tbody><tr><td class="uk-text-left"><code>context</code></td><td class="uk-text-left">oneOf [&quot;success&quot;, &quot;warning&quot;, &quot;danger&quot;]</td></tr><tr><td class="uk-text-left"><code>block</code></td><td class="uk-text-left">bool</td></tr><tr><td class="uk-text-left"><code>body</code></td><td class="uk-text-left">string</td></tr><tr><td class="uk-text-left"><code>notification</code></td><td class="uk-text-left">bool</td></tr></tbody></table></section><section><h2>Tests</h2><p><code>npm run test</code> to run tests with minimal output.<br/><code>npm run test:spec</code> to run tests with detailed output.<br/><code>npm run test:watch</code>watches all directories and run tests with minimal output on file changes.<br/></p></section><section><h2>Build</h2><p><code>npm run build</code> to build files fro distribution.<br/><code>npm run build:watch</code> watches src directory and builds files on changes.<br/></p></section><section><h2>Lint</h2><p><code>npm run lint</code> lints scripts in src directory.<br/><code>npm run lint:watch</code> watches src directory and lints scripts in src directory.<br/></p></section><section><h2>License</h2><p>MIT</p></section></div>